// This file is part of the SV-Benchmarks collection of verification tasks:
// https://gitlab.com/sosy-lab/benchmarking/sv-benchmarks
//
// SPDX-FileCopyrightText: 2023 Levente Bajczi, Department of Measurement and Information Systems, Budapest University of Technology and Economics
//
// SPDX-License-Identifier: Apache-2.0

// Original CHC file: vmt-chc-benchmarks/vmt-PRODUCER_CONSUMER_2_000.smt2
extern void abort ();
extern int __VERIFIER_nondet_int ();
extern _Bool __VERIFIER_nondet__Bool ();
extern void __assert_fail(const char *, const char *, unsigned int, const char *) __attribute__ ((__nothrow__ , __leaf__)) __attribute__ ((__noreturn__));
void reach_error() { __assert_fail("0", "vmt-PRODUCER_CONSUMER_2_000_range.c", 13, "reach_error"); }



int main ();

int
main ()
{
    // return parameter


    // variables
    int state_0;
    int state_1;
    _Bool state_2;
    _Bool state_3;
    int state_4;
    int state_5;
    int state_6;
    int state_7;
    int state_8;
    int state_9;
    int state_10;
    int state_11;
    int state_12;
    int state_13;
    int state_14;
    int state_15;
    _Bool state_16;
    int state_17;
    int state_18;
    int state_19;
    _Bool state_20;
    _Bool state_21;
    _Bool state_22;
    int state_23;
    int state_24;
    int state_25;
    int state_26;
    int state_27;
    _Bool state_28;
    int state_29;
    _Bool state_30;
    int state_31;
    int state_32;
    int state_33;
    int state_34;
    int state_35;
    int state_36;
    _Bool state_37;
    _Bool state_38;
    _Bool state_39;
    _Bool A_0;
    int B_0;
    _Bool C_0;
    _Bool D_0;
    _Bool E_0;
    int F_0;
    _Bool G_0;
    _Bool H_0;
    int I_0;
    int J_0;
    int K_0;
    int L_0;
    int M_0;
    int N_0;
    int O_0;
    int P_0;
    int Q_0;
    _Bool R_0;
    int S_0;
    _Bool T_0;
    _Bool U_0;
    int V_0;
    int W_0;
    int X_0;
    int Y_0;
    int Z_0;
    int A1_0;
    int B1_0;
    int C1_0;
    int D1_0;
    _Bool E1_0;
    int F1_0;
    int G1_0;
    int H1_0;
    int I1_0;
    int J1_0;
    int K1_0;
    int L1_0;
    int M1_0;
    _Bool N1_0;
    _Bool A_1;
    int B_1;
    _Bool C_1;
    _Bool D_1;
    _Bool E_1;
    int F_1;
    int G_1;
    _Bool H_1;
    _Bool I_1;
    int J_1;
    int K_1;
    int L_1;
    int M_1;
    int N_1;
    int O_1;
    int P_1;
    int Q_1;
    int R_1;
    _Bool S_1;
    int T_1;
    _Bool U_1;
    _Bool V_1;
    int W_1;
    int X_1;
    int Y_1;
    int Z_1;
    int A1_1;
    int B1_1;
    int C1_1;
    int D1_1;
    int E1_1;
    _Bool F1_1;
    int G1_1;
    int H1_1;
    int I1_1;
    int J1_1;
    int K1_1;
    int L1_1;
    int M1_1;
    _Bool N1_1;
    int O1_1;
    _Bool P1_1;
    int Q1_1;
    _Bool R1_1;
    int S1_1;
    int T1_1;
    _Bool U1_1;
    int V1_1;
    _Bool W1_1;
    int X1_1;
    int Y1_1;
    _Bool Z1_1;
    int A2_1;
    _Bool B2_1;
    int C2_1;
    int D2_1;
    int E2_1;
    int F2_1;
    int G2_1;
    int H2_1;
    _Bool I2_1;
    int J2_1;
    _Bool K2_1;
    _Bool L2_1;
    int M2_1;
    int N2_1;
    int O2_1;
    int P2_1;
    int Q2_1;
    int R2_1;
    int S2_1;
    int T2_1;
    int U2_1;
    int V2_1;
    _Bool W2_1;
    int X2_1;
    int Y2_1;
    int Z2_1;
    int A3_1;
    _Bool B3_1;
    _Bool A_2;
    int B_2;
    _Bool C_2;
    _Bool D_2;
    _Bool E_2;
    int F_2;
    _Bool G_2;
    _Bool H_2;
    int I_2;
    int J_2;
    int K_2;
    int L_2;
    int M_2;
    int N_2;
    int O_2;
    int P_2;
    int Q_2;
    _Bool R_2;
    int S_2;
    _Bool T_2;
    _Bool U_2;
    int V_2;
    int W_2;
    int X_2;
    int Y_2;
    int Z_2;
    int A1_2;
    int B1_2;
    int C1_2;
    int D1_2;
    _Bool E1_2;
    int F1_2;
    int G1_2;
    int H1_2;
    int I1_2;
    int J1_2;
    int K1_2;
    int L1_2;
    int M1_2;
    _Bool N1_2;

    if (((state_0 <= -1000000000) || (state_0 >= 1000000000))
        || ((state_1 <= -1000000000) || (state_1 >= 1000000000))
        || ((state_4 <= -1000000000) || (state_4 >= 1000000000))
        || ((state_5 <= -1000000000) || (state_5 >= 1000000000))
        || ((state_6 <= -1000000000) || (state_6 >= 1000000000))
        || ((state_7 <= -1000000000) || (state_7 >= 1000000000))
        || ((state_8 <= -1000000000) || (state_8 >= 1000000000))
        || ((state_9 <= -1000000000) || (state_9 >= 1000000000))
        || ((state_10 <= -1000000000) || (state_10 >= 1000000000))
        || ((state_11 <= -1000000000) || (state_11 >= 1000000000))
        || ((state_12 <= -1000000000) || (state_12 >= 1000000000))
        || ((state_13 <= -1000000000) || (state_13 >= 1000000000))
        || ((state_14 <= -1000000000) || (state_14 >= 1000000000))
        || ((state_15 <= -1000000000) || (state_15 >= 1000000000))
        || ((state_17 <= -1000000000) || (state_17 >= 1000000000))
        || ((state_18 <= -1000000000) || (state_18 >= 1000000000))
        || ((state_19 <= -1000000000) || (state_19 >= 1000000000))
        || ((state_23 <= -1000000000) || (state_23 >= 1000000000))
        || ((state_24 <= -1000000000) || (state_24 >= 1000000000))
        || ((state_25 <= -1000000000) || (state_25 >= 1000000000))
        || ((state_26 <= -1000000000) || (state_26 >= 1000000000))
        || ((state_27 <= -1000000000) || (state_27 >= 1000000000))
        || ((state_29 <= -1000000000) || (state_29 >= 1000000000))
        || ((state_31 <= -1000000000) || (state_31 >= 1000000000))
        || ((state_32 <= -1000000000) || (state_32 >= 1000000000))
        || ((state_33 <= -1000000000) || (state_33 >= 1000000000))
        || ((state_34 <= -1000000000) || (state_34 >= 1000000000))
        || ((state_35 <= -1000000000) || (state_35 >= 1000000000))
        || ((state_36 <= -1000000000) || (state_36 >= 1000000000))
        || ((B_0 <= -1000000000) || (B_0 >= 1000000000))
        || ((F_0 <= -1000000000) || (F_0 >= 1000000000))
        || ((I_0 <= -1000000000) || (I_0 >= 1000000000))
        || ((J_0 <= -1000000000) || (J_0 >= 1000000000))
        || ((K_0 <= -1000000000) || (K_0 >= 1000000000))
        || ((L_0 <= -1000000000) || (L_0 >= 1000000000))
        || ((M_0 <= -1000000000) || (M_0 >= 1000000000))
        || ((N_0 <= -1000000000) || (N_0 >= 1000000000))
        || ((O_0 <= -1000000000) || (O_0 >= 1000000000))
        || ((P_0 <= -1000000000) || (P_0 >= 1000000000))
        || ((Q_0 <= -1000000000) || (Q_0 >= 1000000000))
        || ((S_0 <= -1000000000) || (S_0 >= 1000000000))
        || ((V_0 <= -1000000000) || (V_0 >= 1000000000))
        || ((W_0 <= -1000000000) || (W_0 >= 1000000000))
        || ((X_0 <= -1000000000) || (X_0 >= 1000000000))
        || ((Y_0 <= -1000000000) || (Y_0 >= 1000000000))
        || ((Z_0 <= -1000000000) || (Z_0 >= 1000000000))
        || ((A1_0 <= -1000000000) || (A1_0 >= 1000000000))
        || ((B1_0 <= -1000000000) || (B1_0 >= 1000000000))
        || ((C1_0 <= -1000000000) || (C1_0 >= 1000000000))
        || ((D1_0 <= -1000000000) || (D1_0 >= 1000000000))
        || ((F1_0 <= -1000000000) || (F1_0 >= 1000000000))
        || ((G1_0 <= -1000000000) || (G1_0 >= 1000000000))
        || ((H1_0 <= -1000000000) || (H1_0 >= 1000000000))
        || ((I1_0 <= -1000000000) || (I1_0 >= 1000000000))
        || ((J1_0 <= -1000000000) || (J1_0 >= 1000000000))
        || ((K1_0 <= -1000000000) || (K1_0 >= 1000000000))
        || ((L1_0 <= -1000000000) || (L1_0 >= 1000000000))
        || ((M1_0 <= -1000000000) || (M1_0 >= 1000000000))
        || ((B_1 <= -1000000000) || (B_1 >= 1000000000))
        || ((F_1 <= -1000000000) || (F_1 >= 1000000000))
        || ((G_1 <= -1000000000) || (G_1 >= 1000000000))
        || ((J_1 <= -1000000000) || (J_1 >= 1000000000))
        || ((K_1 <= -1000000000) || (K_1 >= 1000000000))
        || ((L_1 <= -1000000000) || (L_1 >= 1000000000))
        || ((M_1 <= -1000000000) || (M_1 >= 1000000000))
        || ((N_1 <= -1000000000) || (N_1 >= 1000000000))
        || ((O_1 <= -1000000000) || (O_1 >= 1000000000))
        || ((P_1 <= -1000000000) || (P_1 >= 1000000000))
        || ((Q_1 <= -1000000000) || (Q_1 >= 1000000000))
        || ((R_1 <= -1000000000) || (R_1 >= 1000000000))
        || ((T_1 <= -1000000000) || (T_1 >= 1000000000))
        || ((W_1 <= -1000000000) || (W_1 >= 1000000000))
        || ((X_1 <= -1000000000) || (X_1 >= 1000000000))
        || ((Y_1 <= -1000000000) || (Y_1 >= 1000000000))
        || ((Z_1 <= -1000000000) || (Z_1 >= 1000000000))
        || ((A1_1 <= -1000000000) || (A1_1 >= 1000000000))
        || ((B1_1 <= -1000000000) || (B1_1 >= 1000000000))
        || ((C1_1 <= -1000000000) || (C1_1 >= 1000000000))
        || ((D1_1 <= -1000000000) || (D1_1 >= 1000000000))
        || ((E1_1 <= -1000000000) || (E1_1 >= 1000000000))
        || ((G1_1 <= -1000000000) || (G1_1 >= 1000000000))
        || ((H1_1 <= -1000000000) || (H1_1 >= 1000000000))
        || ((I1_1 <= -1000000000) || (I1_1 >= 1000000000))
        || ((J1_1 <= -1000000000) || (J1_1 >= 1000000000))
        || ((K1_1 <= -1000000000) || (K1_1 >= 1000000000))
        || ((L1_1 <= -1000000000) || (L1_1 >= 1000000000))
        || ((M1_1 <= -1000000000) || (M1_1 >= 1000000000))
        || ((O1_1 <= -1000000000) || (O1_1 >= 1000000000))
        || ((Q1_1 <= -1000000000) || (Q1_1 >= 1000000000))
        || ((S1_1 <= -1000000000) || (S1_1 >= 1000000000))
        || ((T1_1 <= -1000000000) || (T1_1 >= 1000000000))
        || ((V1_1 <= -1000000000) || (V1_1 >= 1000000000))
        || ((X1_1 <= -1000000000) || (X1_1 >= 1000000000))
        || ((Y1_1 <= -1000000000) || (Y1_1 >= 1000000000))
        || ((A2_1 <= -1000000000) || (A2_1 >= 1000000000))
        || ((C2_1 <= -1000000000) || (C2_1 >= 1000000000))
        || ((D2_1 <= -1000000000) || (D2_1 >= 1000000000))
        || ((E2_1 <= -1000000000) || (E2_1 >= 1000000000))
        || ((F2_1 <= -1000000000) || (F2_1 >= 1000000000))
        || ((G2_1 <= -1000000000) || (G2_1 >= 1000000000))
        || ((H2_1 <= -1000000000) || (H2_1 >= 1000000000))
        || ((J2_1 <= -1000000000) || (J2_1 >= 1000000000))
        || ((M2_1 <= -1000000000) || (M2_1 >= 1000000000))
        || ((N2_1 <= -1000000000) || (N2_1 >= 1000000000))
        || ((O2_1 <= -1000000000) || (O2_1 >= 1000000000))
        || ((P2_1 <= -1000000000) || (P2_1 >= 1000000000))
        || ((Q2_1 <= -1000000000) || (Q2_1 >= 1000000000))
        || ((R2_1 <= -1000000000) || (R2_1 >= 1000000000))
        || ((S2_1 <= -1000000000) || (S2_1 >= 1000000000))
        || ((T2_1 <= -1000000000) || (T2_1 >= 1000000000))
        || ((U2_1 <= -1000000000) || (U2_1 >= 1000000000))
        || ((V2_1 <= -1000000000) || (V2_1 >= 1000000000))
        || ((X2_1 <= -1000000000) || (X2_1 >= 1000000000))
        || ((Y2_1 <= -1000000000) || (Y2_1 >= 1000000000))
        || ((Z2_1 <= -1000000000) || (Z2_1 >= 1000000000))
        || ((A3_1 <= -1000000000) || (A3_1 >= 1000000000))
        || ((B_2 <= -1000000000) || (B_2 >= 1000000000))
        || ((F_2 <= -1000000000) || (F_2 >= 1000000000))
        || ((I_2 <= -1000000000) || (I_2 >= 1000000000))
        || ((J_2 <= -1000000000) || (J_2 >= 1000000000))
        || ((K_2 <= -1000000000) || (K_2 >= 1000000000))
        || ((L_2 <= -1000000000) || (L_2 >= 1000000000))
        || ((M_2 <= -1000000000) || (M_2 >= 1000000000))
        || ((N_2 <= -1000000000) || (N_2 >= 1000000000))
        || ((O_2 <= -1000000000) || (O_2 >= 1000000000))
        || ((P_2 <= -1000000000) || (P_2 >= 1000000000))
        || ((Q_2 <= -1000000000) || (Q_2 >= 1000000000))
        || ((S_2 <= -1000000000) || (S_2 >= 1000000000))
        || ((V_2 <= -1000000000) || (V_2 >= 1000000000))
        || ((W_2 <= -1000000000) || (W_2 >= 1000000000))
        || ((X_2 <= -1000000000) || (X_2 >= 1000000000))
        || ((Y_2 <= -1000000000) || (Y_2 >= 1000000000))
        || ((Z_2 <= -1000000000) || (Z_2 >= 1000000000))
        || ((A1_2 <= -1000000000) || (A1_2 >= 1000000000))
        || ((B1_2 <= -1000000000) || (B1_2 >= 1000000000))
        || ((C1_2 <= -1000000000) || (C1_2 >= 1000000000))
        || ((D1_2 <= -1000000000) || (D1_2 >= 1000000000))
        || ((F1_2 <= -1000000000) || (F1_2 >= 1000000000))
        || ((G1_2 <= -1000000000) || (G1_2 >= 1000000000))
        || ((H1_2 <= -1000000000) || (H1_2 >= 1000000000))
        || ((I1_2 <= -1000000000) || (I1_2 >= 1000000000))
        || ((J1_2 <= -1000000000) || (J1_2 >= 1000000000))
        || ((K1_2 <= -1000000000) || (K1_2 >= 1000000000))
        || ((L1_2 <= -1000000000) || (L1_2 >= 1000000000))
        || ((M1_2 <= -1000000000) || (M1_2 >= 1000000000)))
        abort ();

    // main logic
    goto main_init;

  main_init:
    if (!
        (((A_0 && E1_0 && (!(F1_0 <= 0))) == U_0) && (!((G_0 && H_0) == R_0))
         && (R_0 == E1_0) && (!(N1_0 == A_0)) && (W_0 == V_0) && (L_0 == K_0)
         && (L_0 == Z_0) && (K_0 == W_0) && (M_0 == 0) && (M_0 == Y_0)
         && (O_0 == N_0) && (O_0 == L_0) && (P_0 == 0) && (P_0 == B1_0)
         && (Q_0 == 0) && (Q_0 == D1_0) && (S_0 == N_0) && (S_0 == F1_0)
         && (Y_0 == X_0) && (B1_0 == A1_0) && (D1_0 == C1_0) && ((!H_0)
                                                                 || (J_0 ==
                                                                     I_0))
         && ((!N1_0) || (M1_0 == L1_0)) && ((!N1_0) || (G1_0 == I1_0))
         && (N1_0 || (H1_0 == G1_0)) && ((!G_0) || (F_0 == B_0)) && (G_0
                                                                     || (H1_0
                                                                         ==
                                                                         J1_0))
         && ((!G_0) || (H1_0 == K1_0)) && (((!U_0) || (0 <= V_0)) == T_0)))
        abort ();
    state_0 = S_0;
    state_1 = F1_0;
    state_2 = R_0;
    state_3 = E1_0;
    state_4 = Q_0;
    state_5 = D1_0;
    state_6 = P_0;
    state_7 = B1_0;
    state_8 = O_0;
    state_9 = L_0;
    state_10 = M_0;
    state_11 = Y_0;
    state_12 = K_0;
    state_13 = W_0;
    state_14 = H1_0;
    state_15 = K1_0;
    state_16 = G_0;
    state_17 = J1_0;
    state_18 = G1_0;
    state_19 = I1_0;
    state_20 = N1_0;
    state_21 = A_0;
    state_22 = U_0;
    state_23 = C1_0;
    state_24 = A1_0;
    state_25 = Z_0;
    state_26 = X_0;
    state_27 = V_0;
    state_28 = T_0;
    state_29 = N_0;
    state_30 = H_0;
    state_31 = J_0;
    state_32 = I_0;
    state_33 = F_0;
    state_34 = B_0;
    state_35 = M1_0;
    state_36 = L1_0;
    state_37 = C_0;
    state_38 = D_0;
    state_39 = E_0;
    Q1_1 = __VERIFIER_nondet_int ();
    if (((Q1_1 <= -1000000000) || (Q1_1 >= 1000000000)))
        abort ();
    Q2_1 = __VERIFIER_nondet_int ();
    if (((Q2_1 <= -1000000000) || (Q2_1 >= 1000000000)))
        abort ();
    M1_1 = __VERIFIER_nondet_int ();
    if (((M1_1 <= -1000000000) || (M1_1 >= 1000000000)))
        abort ();
    M2_1 = __VERIFIER_nondet_int ();
    if (((M2_1 <= -1000000000) || (M2_1 >= 1000000000)))
        abort ();
    I2_1 = __VERIFIER_nondet__Bool ();
    E2_1 = __VERIFIER_nondet_int ();
    if (((E2_1 <= -1000000000) || (E2_1 >= 1000000000)))
        abort ();
    A2_1 = __VERIFIER_nondet_int ();
    if (((A2_1 <= -1000000000) || (A2_1 >= 1000000000)))
        abort ();
    Z1_1 = __VERIFIER_nondet__Bool ();
    V1_1 = __VERIFIER_nondet_int ();
    if (((V1_1 <= -1000000000) || (V1_1 >= 1000000000)))
        abort ();
    V2_1 = __VERIFIER_nondet_int ();
    if (((V2_1 <= -1000000000) || (V2_1 >= 1000000000)))
        abort ();
    R1_1 = __VERIFIER_nondet__Bool ();
    R2_1 = __VERIFIER_nondet_int ();
    if (((R2_1 <= -1000000000) || (R2_1 >= 1000000000)))
        abort ();
    N1_1 = __VERIFIER_nondet__Bool ();
    N2_1 = __VERIFIER_nondet_int ();
    if (((N2_1 <= -1000000000) || (N2_1 >= 1000000000)))
        abort ();
    J2_1 = __VERIFIER_nondet_int ();
    if (((J2_1 <= -1000000000) || (J2_1 >= 1000000000)))
        abort ();
    F2_1 = __VERIFIER_nondet_int ();
    if (((F2_1 <= -1000000000) || (F2_1 >= 1000000000)))
        abort ();
    B2_1 = __VERIFIER_nondet__Bool ();
    W1_1 = __VERIFIER_nondet__Bool ();
    W2_1 = __VERIFIER_nondet__Bool ();
    S1_1 = __VERIFIER_nondet_int ();
    if (((S1_1 <= -1000000000) || (S1_1 >= 1000000000)))
        abort ();
    S2_1 = __VERIFIER_nondet_int ();
    if (((S2_1 <= -1000000000) || (S2_1 >= 1000000000)))
        abort ();
    O1_1 = __VERIFIER_nondet_int ();
    if (((O1_1 <= -1000000000) || (O1_1 >= 1000000000)))
        abort ();
    O2_1 = __VERIFIER_nondet_int ();
    if (((O2_1 <= -1000000000) || (O2_1 >= 1000000000)))
        abort ();
    F_1 = __VERIFIER_nondet_int ();
    if (((F_1 <= -1000000000) || (F_1 >= 1000000000)))
        abort ();
    K2_1 = __VERIFIER_nondet__Bool ();
    G2_1 = __VERIFIER_nondet_int ();
    if (((G2_1 <= -1000000000) || (G2_1 >= 1000000000)))
        abort ();
    C2_1 = __VERIFIER_nondet_int ();
    if (((C2_1 <= -1000000000) || (C2_1 >= 1000000000)))
        abort ();
    X1_1 = __VERIFIER_nondet_int ();
    if (((X1_1 <= -1000000000) || (X1_1 >= 1000000000)))
        abort ();
    X2_1 = __VERIFIER_nondet_int ();
    if (((X2_1 <= -1000000000) || (X2_1 >= 1000000000)))
        abort ();
    T1_1 = __VERIFIER_nondet_int ();
    if (((T1_1 <= -1000000000) || (T1_1 >= 1000000000)))
        abort ();
    T2_1 = __VERIFIER_nondet_int ();
    if (((T2_1 <= -1000000000) || (T2_1 >= 1000000000)))
        abort ();
    P1_1 = __VERIFIER_nondet__Bool ();
    P2_1 = __VERIFIER_nondet_int ();
    if (((P2_1 <= -1000000000) || (P2_1 >= 1000000000)))
        abort ();
    L2_1 = __VERIFIER_nondet__Bool ();
    H2_1 = __VERIFIER_nondet_int ();
    if (((H2_1 <= -1000000000) || (H2_1 >= 1000000000)))
        abort ();
    D2_1 = __VERIFIER_nondet_int ();
    if (((D2_1 <= -1000000000) || (D2_1 >= 1000000000)))
        abort ();
    Y1_1 = __VERIFIER_nondet_int ();
    if (((Y1_1 <= -1000000000) || (Y1_1 >= 1000000000)))
        abort ();
    Y2_1 = __VERIFIER_nondet_int ();
    if (((Y2_1 <= -1000000000) || (Y2_1 >= 1000000000)))
        abort ();
    U1_1 = __VERIFIER_nondet__Bool ();
    U2_1 = __VERIFIER_nondet_int ();
    if (((U2_1 <= -1000000000) || (U2_1 >= 1000000000)))
        abort ();
    T_1 = state_0;
    G1_1 = state_1;
    S_1 = state_2;
    F1_1 = state_3;
    R_1 = state_4;
    E1_1 = state_5;
    Q_1 = state_6;
    C1_1 = state_7;
    P_1 = state_8;
    M_1 = state_9;
    N_1 = state_10;
    Z_1 = state_11;
    L_1 = state_12;
    X_1 = state_13;
    I1_1 = state_14;
    L1_1 = state_15;
    H_1 = state_16;
    K1_1 = state_17;
    H1_1 = state_18;
    J1_1 = state_19;
    B3_1 = state_20;
    A_1 = state_21;
    V_1 = state_22;
    D1_1 = state_23;
    B1_1 = state_24;
    A1_1 = state_25;
    Y_1 = state_26;
    W_1 = state_27;
    U_1 = state_28;
    O_1 = state_29;
    I_1 = state_30;
    K_1 = state_31;
    J_1 = state_32;
    G_1 = state_33;
    B_1 = state_34;
    A3_1 = state_35;
    Z2_1 = state_36;
    C_1 = state_37;
    D_1 = state_38;
    E_1 = state_39;
    if (!
        (((1 <= Z_1) == B2_1) && ((1 <= X_1) == W1_1)
         && (((!L2_1) || (0 <= M2_1)) == K2_1)
         && (((!V_1) || (0 <= W_1)) == U_1)
         && ((W2_1 && P1_1 && (!(X2_1 <= 0))) == L2_1)
         && ((A_1 && F1_1 && (!(G1_1 <= 0))) == V_1)
         && (I2_1 == (F1_1 && ((!U1_1) || (!R1_1)))) && (W2_1 == I2_1)
         && (S_1 == F1_1) && (C2_1 == M1_1) && (E2_1 == D2_1)
         && (G2_1 == Q1_1) && (H2_1 == T1_1) && (N2_1 == C2_1)
         && (N2_1 == M2_1) && (P2_1 == E2_1) && (P2_1 == O2_1)
         && (R2_1 == F2_1) && (R2_1 == Q2_1) && (T2_1 == G2_1)
         && (T2_1 == S2_1) && (V2_1 == H2_1) && (V2_1 == U2_1)
         && (X2_1 == J2_1) && (G1_1 == J2_1) && (E1_1 == D1_1)
         && (C1_1 == B1_1) && (Z_1 == Y_1) && (X_1 == W_1) && (T_1 == G1_1)
         && (R_1 == E1_1) && (Q_1 == C1_1) && (P_1 == M_1) && (N_1 == Z_1)
         && (M_1 == F2_1) && (M_1 == A1_1) && (L_1 == X_1) && (B3_1
                                                               || (I1_1 ==
                                                                   H1_1))
         && ((!B3_1) || (H1_1 == J1_1)) && ((!N1_1) || (M1_1 == O1_1))
         && ((!N1_1) || (X1_1 == D2_1)) && (N1_1 || (X_1 == M1_1)) && (N1_1
                                                                       ||
                                                                       (Y2_1
                                                                        ==
                                                                        D2_1))
         && ((!R1_1) || (Q1_1 == S1_1)) && ((!R1_1) || (Y1_1 == Y2_1))
         && (R1_1 || (C1_1 == Q1_1)) && (R1_1 || (Y2_1 == A2_1)) && ((!U1_1)
                                                                     || (T1_1
                                                                         ==
                                                                         V1_1))
         && (U1_1 || (E1_1 == T1_1)) && ((!W1_1)
                                         || ((Z_1 + (-1 * X1_1)) == -1))
         && ((!W1_1) || ((X_1 + (-1 * O1_1)) == 1)) && (W1_1 || (Z_1 == X1_1))
         && (W1_1 || (X_1 == O1_1)) && ((!Z1_1)
                                        || ((C1_1 + (-1 * S1_1)) == -1))
         && ((!Z1_1) || ((Z_1 + (-1 * Y1_1)) == 1)) && (Z1_1
                                                        || (C1_1 == S1_1))
         && (Z1_1 || (Z_1 == Y1_1)) && ((!B2_1)
                                        || ((E1_1 + (-1 * V1_1)) == -1))
         && ((!B2_1) || ((Z_1 + (-1 * A2_1)) == 1)) && (B2_1
                                                        || (E1_1 == V1_1))
         && (B2_1 || (Z_1 == A2_1)) && ((!H_1) || (I1_1 == L1_1)) && (H_1
                                                                      || (I1_1
                                                                          ==
                                                                          K1_1))
         && P1_1 && ((1 <= Z_1) == Z1_1)))
        abort ();
    state_0 = J2_1;
    state_1 = X2_1;
    state_2 = I2_1;
    state_3 = W2_1;
    state_4 = H2_1;
    state_5 = V2_1;
    state_6 = G2_1;
    state_7 = T2_1;
    state_8 = F2_1;
    state_9 = R2_1;
    state_10 = E2_1;
    state_11 = P2_1;
    state_12 = C2_1;
    state_13 = N2_1;
    state_14 = Y2_1;
    state_15 = Y1_1;
    state_16 = R1_1;
    state_17 = A2_1;
    state_18 = D2_1;
    state_19 = X1_1;
    state_20 = N1_1;
    state_21 = P1_1;
    state_22 = L2_1;
    state_23 = U2_1;
    state_24 = S2_1;
    state_25 = Q2_1;
    state_26 = O2_1;
    state_27 = M2_1;
    state_28 = K2_1;
    state_29 = F_1;
    state_30 = U1_1;
    state_31 = T1_1;
    state_32 = V1_1;
    state_33 = Q1_1;
    state_34 = S1_1;
    state_35 = M1_1;
    state_36 = O1_1;
    state_37 = W1_1;
    state_38 = Z1_1;
    state_39 = B2_1;
    goto state_0;
  main_error:
    reach_error ();
  main_final:
    goto main_final;
  state_0:
    switch (__VERIFIER_nondet__Bool ())
      {
      case 0:
          S_2 = state_0;
          F1_2 = state_1;
          R_2 = state_2;
          E1_2 = state_3;
          Q_2 = state_4;
          D1_2 = state_5;
          P_2 = state_6;
          B1_2 = state_7;
          O_2 = state_8;
          L_2 = state_9;
          M_2 = state_10;
          Y_2 = state_11;
          K_2 = state_12;
          W_2 = state_13;
          H1_2 = state_14;
          K1_2 = state_15;
          G_2 = state_16;
          J1_2 = state_17;
          G1_2 = state_18;
          I1_2 = state_19;
          N1_2 = state_20;
          A_2 = state_21;
          U_2 = state_22;
          C1_2 = state_23;
          A1_2 = state_24;
          Z_2 = state_25;
          X_2 = state_26;
          V_2 = state_27;
          T_2 = state_28;
          N_2 = state_29;
          H_2 = state_30;
          J_2 = state_31;
          I_2 = state_32;
          F_2 = state_33;
          B_2 = state_34;
          M1_2 = state_35;
          L1_2 = state_36;
          C_2 = state_37;
          D_2 = state_38;
          E_2 = state_39;
          if (!(!T_2))
              abort ();
          goto main_error;

      case 1:
          Q1_1 = __VERIFIER_nondet_int ();
          if (((Q1_1 <= -1000000000) || (Q1_1 >= 1000000000)))
              abort ();
          Q2_1 = __VERIFIER_nondet_int ();
          if (((Q2_1 <= -1000000000) || (Q2_1 >= 1000000000)))
              abort ();
          M1_1 = __VERIFIER_nondet_int ();
          if (((M1_1 <= -1000000000) || (M1_1 >= 1000000000)))
              abort ();
          M2_1 = __VERIFIER_nondet_int ();
          if (((M2_1 <= -1000000000) || (M2_1 >= 1000000000)))
              abort ();
          I2_1 = __VERIFIER_nondet__Bool ();
          E2_1 = __VERIFIER_nondet_int ();
          if (((E2_1 <= -1000000000) || (E2_1 >= 1000000000)))
              abort ();
          A2_1 = __VERIFIER_nondet_int ();
          if (((A2_1 <= -1000000000) || (A2_1 >= 1000000000)))
              abort ();
          Z1_1 = __VERIFIER_nondet__Bool ();
          V1_1 = __VERIFIER_nondet_int ();
          if (((V1_1 <= -1000000000) || (V1_1 >= 1000000000)))
              abort ();
          V2_1 = __VERIFIER_nondet_int ();
          if (((V2_1 <= -1000000000) || (V2_1 >= 1000000000)))
              abort ();
          R1_1 = __VERIFIER_nondet__Bool ();
          R2_1 = __VERIFIER_nondet_int ();
          if (((R2_1 <= -1000000000) || (R2_1 >= 1000000000)))
              abort ();
          N1_1 = __VERIFIER_nondet__Bool ();
          N2_1 = __VERIFIER_nondet_int ();
          if (((N2_1 <= -1000000000) || (N2_1 >= 1000000000)))
              abort ();
          J2_1 = __VERIFIER_nondet_int ();
          if (((J2_1 <= -1000000000) || (J2_1 >= 1000000000)))
              abort ();
          F2_1 = __VERIFIER_nondet_int ();
          if (((F2_1 <= -1000000000) || (F2_1 >= 1000000000)))
              abort ();
          B2_1 = __VERIFIER_nondet__Bool ();
          W1_1 = __VERIFIER_nondet__Bool ();
          W2_1 = __VERIFIER_nondet__Bool ();
          S1_1 = __VERIFIER_nondet_int ();
          if (((S1_1 <= -1000000000) || (S1_1 >= 1000000000)))
              abort ();
          S2_1 = __VERIFIER_nondet_int ();
          if (((S2_1 <= -1000000000) || (S2_1 >= 1000000000)))
              abort ();
          O1_1 = __VERIFIER_nondet_int ();
          if (((O1_1 <= -1000000000) || (O1_1 >= 1000000000)))
              abort ();
          O2_1 = __VERIFIER_nondet_int ();
          if (((O2_1 <= -1000000000) || (O2_1 >= 1000000000)))
              abort ();
          F_1 = __VERIFIER_nondet_int ();
          if (((F_1 <= -1000000000) || (F_1 >= 1000000000)))
              abort ();
          K2_1 = __VERIFIER_nondet__Bool ();
          G2_1 = __VERIFIER_nondet_int ();
          if (((G2_1 <= -1000000000) || (G2_1 >= 1000000000)))
              abort ();
          C2_1 = __VERIFIER_nondet_int ();
          if (((C2_1 <= -1000000000) || (C2_1 >= 1000000000)))
              abort ();
          X1_1 = __VERIFIER_nondet_int ();
          if (((X1_1 <= -1000000000) || (X1_1 >= 1000000000)))
              abort ();
          X2_1 = __VERIFIER_nondet_int ();
          if (((X2_1 <= -1000000000) || (X2_1 >= 1000000000)))
              abort ();
          T1_1 = __VERIFIER_nondet_int ();
          if (((T1_1 <= -1000000000) || (T1_1 >= 1000000000)))
              abort ();
          T2_1 = __VERIFIER_nondet_int ();
          if (((T2_1 <= -1000000000) || (T2_1 >= 1000000000)))
              abort ();
          P1_1 = __VERIFIER_nondet__Bool ();
          P2_1 = __VERIFIER_nondet_int ();
          if (((P2_1 <= -1000000000) || (P2_1 >= 1000000000)))
              abort ();
          L2_1 = __VERIFIER_nondet__Bool ();
          H2_1 = __VERIFIER_nondet_int ();
          if (((H2_1 <= -1000000000) || (H2_1 >= 1000000000)))
              abort ();
          D2_1 = __VERIFIER_nondet_int ();
          if (((D2_1 <= -1000000000) || (D2_1 >= 1000000000)))
              abort ();
          Y1_1 = __VERIFIER_nondet_int ();
          if (((Y1_1 <= -1000000000) || (Y1_1 >= 1000000000)))
              abort ();
          Y2_1 = __VERIFIER_nondet_int ();
          if (((Y2_1 <= -1000000000) || (Y2_1 >= 1000000000)))
              abort ();
          U1_1 = __VERIFIER_nondet__Bool ();
          U2_1 = __VERIFIER_nondet_int ();
          if (((U2_1 <= -1000000000) || (U2_1 >= 1000000000)))
              abort ();
          T_1 = state_0;
          G1_1 = state_1;
          S_1 = state_2;
          F1_1 = state_3;
          R_1 = state_4;
          E1_1 = state_5;
          Q_1 = state_6;
          C1_1 = state_7;
          P_1 = state_8;
          M_1 = state_9;
          N_1 = state_10;
          Z_1 = state_11;
          L_1 = state_12;
          X_1 = state_13;
          I1_1 = state_14;
          L1_1 = state_15;
          H_1 = state_16;
          K1_1 = state_17;
          H1_1 = state_18;
          J1_1 = state_19;
          B3_1 = state_20;
          A_1 = state_21;
          V_1 = state_22;
          D1_1 = state_23;
          B1_1 = state_24;
          A1_1 = state_25;
          Y_1 = state_26;
          W_1 = state_27;
          U_1 = state_28;
          O_1 = state_29;
          I_1 = state_30;
          K_1 = state_31;
          J_1 = state_32;
          G_1 = state_33;
          B_1 = state_34;
          A3_1 = state_35;
          Z2_1 = state_36;
          C_1 = state_37;
          D_1 = state_38;
          E_1 = state_39;
          if (!
              (((1 <= Z_1) == B2_1) && ((1 <= X_1) == W1_1)
               && (((!L2_1) || (0 <= M2_1)) == K2_1)
               && (((!V_1) || (0 <= W_1)) == U_1)
               && ((W2_1 && P1_1 && (!(X2_1 <= 0))) == L2_1)
               && ((A_1 && F1_1 && (!(G1_1 <= 0))) == V_1)
               && (I2_1 == (F1_1 && ((!U1_1) || (!R1_1)))) && (W2_1 == I2_1)
               && (S_1 == F1_1) && (C2_1 == M1_1) && (E2_1 == D2_1)
               && (G2_1 == Q1_1) && (H2_1 == T1_1) && (N2_1 == C2_1)
               && (N2_1 == M2_1) && (P2_1 == E2_1) && (P2_1 == O2_1)
               && (R2_1 == F2_1) && (R2_1 == Q2_1) && (T2_1 == G2_1)
               && (T2_1 == S2_1) && (V2_1 == H2_1) && (V2_1 == U2_1)
               && (X2_1 == J2_1) && (G1_1 == J2_1) && (E1_1 == D1_1)
               && (C1_1 == B1_1) && (Z_1 == Y_1) && (X_1 == W_1)
               && (T_1 == G1_1) && (R_1 == E1_1) && (Q_1 == C1_1)
               && (P_1 == M_1) && (N_1 == Z_1) && (M_1 == F2_1)
               && (M_1 == A1_1) && (L_1 == X_1) && (B3_1 || (I1_1 == H1_1))
               && ((!B3_1) || (H1_1 == J1_1)) && ((!N1_1) || (M1_1 == O1_1))
               && ((!N1_1) || (X1_1 == D2_1)) && (N1_1 || (X_1 == M1_1))
               && (N1_1 || (Y2_1 == D2_1)) && ((!R1_1) || (Q1_1 == S1_1))
               && ((!R1_1) || (Y1_1 == Y2_1)) && (R1_1 || (C1_1 == Q1_1))
               && (R1_1 || (Y2_1 == A2_1)) && ((!U1_1) || (T1_1 == V1_1))
               && (U1_1 || (E1_1 == T1_1)) && ((!W1_1)
                                               || ((Z_1 + (-1 * X1_1)) == -1))
               && ((!W1_1) || ((X_1 + (-1 * O1_1)) == 1)) && (W1_1
                                                              || (Z_1 ==
                                                                  X1_1))
               && (W1_1 || (X_1 == O1_1)) && ((!Z1_1)
                                              || ((C1_1 + (-1 * S1_1)) == -1))
               && ((!Z1_1) || ((Z_1 + (-1 * Y1_1)) == 1)) && (Z1_1
                                                              || (C1_1 ==
                                                                  S1_1))
               && (Z1_1 || (Z_1 == Y1_1)) && ((!B2_1)
                                              || ((E1_1 + (-1 * V1_1)) == -1))
               && ((!B2_1) || ((Z_1 + (-1 * A2_1)) == 1)) && (B2_1
                                                              || (E1_1 ==
                                                                  V1_1))
               && (B2_1 || (Z_1 == A2_1)) && ((!H_1) || (I1_1 == L1_1))
               && (H_1 || (I1_1 == K1_1)) && P1_1 && ((1 <= Z_1) == Z1_1)))
              abort ();
          state_0 = J2_1;
          state_1 = X2_1;
          state_2 = I2_1;
          state_3 = W2_1;
          state_4 = H2_1;
          state_5 = V2_1;
          state_6 = G2_1;
          state_7 = T2_1;
          state_8 = F2_1;
          state_9 = R2_1;
          state_10 = E2_1;
          state_11 = P2_1;
          state_12 = C2_1;
          state_13 = N2_1;
          state_14 = Y2_1;
          state_15 = Y1_1;
          state_16 = R1_1;
          state_17 = A2_1;
          state_18 = D2_1;
          state_19 = X1_1;
          state_20 = N1_1;
          state_21 = P1_1;
          state_22 = L2_1;
          state_23 = U2_1;
          state_24 = S2_1;
          state_25 = Q2_1;
          state_26 = O2_1;
          state_27 = M2_1;
          state_28 = K2_1;
          state_29 = F_1;
          state_30 = U1_1;
          state_31 = T1_1;
          state_32 = V1_1;
          state_33 = Q1_1;
          state_34 = S1_1;
          state_35 = M1_1;
          state_36 = O1_1;
          state_37 = W1_1;
          state_38 = Z1_1;
          state_39 = B2_1;
          goto state_0;

      default:
          abort ();
      }

    // return expression

}

